Package com.sas.metadata.remote

# Interface PermissionCondition

All Superinterfaces:
  `CMetadata`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `Remote`, `Root`, `SecondaryType`

public interface PermissionCondition extends SecondaryType
Stores an expression that is applied to conditionally grant a user or group access to a resource. The syntax of the expression is not explicitly defined as it varies depending on the resource to which it applies. PermissionCondition objects should not be explicitly created or deleted. PermissionCondition objects are created for you by the authorization tab as appropriate.

Attributes of PermissionCondition are:

- `Text`

Associations of PermissionCondition are:

- `OwningAccessControlEntry`

## Usage

To create an instance of this PermissionCondition, use the `factory` create methods.
Example: create a PermissionCondition with name "PermissionCondition_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     PermissionCondition myObject = (PermissionCondition) factory.createComplexMetadataObject(objectStore, "PermissionCondition_Object", MetadataObjects.PERMISSIONCONDITION, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ASSOCIATION_OWNINGACCESSCONTROLENTRY_NAME`
  Constant used for the name of the OwningAccessControlEntry association.
  `static final String`
  `ATTRIBUTE_TEXT_NAME`
  Constant used for the name of the Text attribute.

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `AccessControlEntry`
  `getOwningAccessControlEntry()`
  Gets the `AccessControlEntry` for `OwningAccessControlEntry`
  `AssociationList`
  `getOwningAccessControlEntrys()`
  Gets the AssociationList of `OwningAccessControlEntrys`
  `AssociationList`
  `getOwningAccessControlEntrys(boolean fGoToServer)`
  Gets the Associationlist of `OwningAccessControlEntrys`
  `String`
  `getText()`
  Gets the `String` value of `Text`
  `int`
  `getTextMaxLength()`
  Gets the maximum length of `Text`
  `int`
  `getTextState()`
  Gets the Metadata State of `Text`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `OwningAccessControlEntry`
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `OwningAccessControlEntry`
  `void`
  `setOwningAccessControlEntry(AccessControlEntry inObject)`
  Sets the `OwningAccessControlEntrys` list 0th element to be `inObject`.
  `void`
  `setOwningAccessControlEntrys(AssociationList list)`
  Sets the `OwningAccessControlEntrys` list to be `list`.
  `void`
  `setOwningAccessControlEntrys(AssociationList list, int state)`
  Sets the `OwningAccessControlEntrys` list to be `list`.
  `void`
  `setText(String inText)`
  Sets the `Text` value and sets the state to MetadataState.LOCAL.
  `void`
  `setText(String inText, int state)`
  Sets the `Text` Metadata State.
  `void`
  `setTextState(int state)`
  Sets the Metadata State of `Text`.

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_TEXT_NAME

    static final String ATTRIBUTE_TEXT_NAME
    Constant used for the name of the Text attribute.

    Text: Condition expression.

    See Also:
      - Constant Field Values

  - ### ASSOCIATION_OWNINGACCESSCONTROLENTRY_NAME

    static final String ASSOCIATION_OWNINGACCESSCONTROLENTRY_NAME
    Constant used for the name of the OwningAccessControlEntry association.

    OwningAccessControlEntry: The access control entry that uses this condition.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    `OwningAccessControlEntry`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Specified by:
      `initializeRequiredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    `OwningAccessControlEntry`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `Root`
    Specified by:
      `initializePredObjects` in interface `SecondaryType`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getText

    String getText() throws RemoteException
    Gets the `String` value of `Text`
    Returns:
      The `Text`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTextState

    int getTextState() throws RemoteException
    Gets the Metadata State of `Text`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getTextMaxLength

    int getTextMaxLength() throws RemoteException
    Gets the maximum length of `Text`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getOwningAccessControlEntrys

    AssociationList getOwningAccessControlEntrys() throws RemoteException, MdException
    Gets the AssociationList of `OwningAccessControlEntrys`
    Returns:
      Returns the AssociationList of `OwningAccessControlEntrys` which can be of type:
      AccessControlEntry
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException`

  - ### getOwningAccessControlEntry

    AccessControlEntry getOwningAccessControlEntry() throws RemoteException, MdException
    Gets the `AccessControlEntry` for `OwningAccessControlEntry`
    Returns:
      The `AccessControlEntry` ( `null` if not set) of `OwningAccessControlEntry`which can be of type:
      AccessControlEntry
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### getOwningAccessControlEntrys

    AssociationList getOwningAccessControlEntrys(boolean fGoToServer) throws RemoteException, MdException
    Gets the Associationlist of `OwningAccessControlEntrys`
    Parameters:
      `fGoToServer` - boolean Get the value from the server.
    Returns:
      Returns the AssociationList of `OwningAccessControlEntrys` which can be of type:
      AccessControlEntry
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.
      `MdException` - If error getting/setting part of the object.

  - ### setText

    void setText(String inText) throws RemoteException
    Sets the `Text` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inText` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setText

    void setText(String inText, int state) throws RemoteException
    Sets the `Text` Metadata State.
    Parameters:
      `inText` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setTextState

    void setTextState(int state) throws RemoteException
    Sets the Metadata State of `Text`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningAccessControlEntrys

    void setOwningAccessControlEntrys(AssociationList list) throws RemoteException
    Sets the `OwningAccessControlEntrys` list to be `list`. Object of which can be of type:
    AccessControlEntry
    Parameters:
      `list` - AssociationList
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningAccessControlEntrys

    void setOwningAccessControlEntrys(AssociationList list, int state) throws RemoteException
    Sets the `OwningAccessControlEntrys` list to be `list`. Object of which can be of type:
    AccessControlEntry
    Parameters:
      `list` - AssociationList
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setOwningAccessControlEntry

    void setOwningAccessControlEntry(AccessControlEntry inObject) throws RemoteException
    Sets the `OwningAccessControlEntrys` list 0th element to be `inObject`.
    Parameters:
      `inObject` - AccessControlEntry
    Throws:
      `RemoteException` - If error communicating with remote object.